//---------------------------------------------------------------------------

#include <vcl.h>
#include <fstream.h>
#include<dos.h>
#include <dir.h>
#include <stdlib.h>
#include <cstring.h>
#pragma hdrstop
#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "sButton"
#pragma link "sComboBox"
#pragma link "sEdit"
#pragma link "ILAnalogInstrument"
#pragma link "ILSegmentGauge"
#pragma link "ILSegmentIndicator"
#pragma link "ILThermometer"
#pragma link "LPComponent"
#pragma link "LPDrawLayers"
#pragma link "LPTransparentControl"
#pragma link "SLComponentCollection"
#pragma link "ULBasicControl"
#pragma link "ILGlassPanel"
#pragma link "ILLed"
#pragma link "sTreeView"
#pragma resource "*.dfm"

TForm1 *Form1;
AnsiString PORT = "COM1" ;
 #include "uart.cpp"
//########################################################
//#         RTC_MK  KIT     #
//#              12.09.2013  alexshipov@gmail.com        #
//########################################################

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  // COM   
    char mip1[24];  //ip -
      mip1[0]='s';


  chdir(""); //   
 // ifstream infile("rtc_mk_adc.ini");
 // infile>>mip1;
  // 
  //infile.close();
    Button1->Enabled=false;
    Button2->Enabled=false;

    EnumerateSerialPorts();

    }
//---------------------------------------------------------------------------


void __fastcall TForm1::sButton1Click(TObject *Sender)
{

    TSerialConnection * SerialConnection = new TSerialConnection(PORT);

 SerialConnection->SendCommand("!"+ sEdit1->Text + "\r");
 Memo1->Lines->Add(SerialConnection->ReceiveCommand());

        delete SerialConnection;

}

//---------------------------------------------------------------------------
void __fastcall TForm1::sComboBox1Select(TObject *Sender)
{  //    
    PORT =  sComboBox1->Items->Strings[sComboBox1->ItemIndex];
   
    Button1->Enabled=true;
    Button2->Enabled=true;

  Timer1->Enabled = true;

 }
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer1Timer(TObject *Sender)
{ //    
     AnsiString Msg;
     TSerialConnection * SerialConnection = new TSerialConnection(PORT);

    //    
    SerialConnection->SendCommand("!Adc0\r");
    //        
    Msg = SerialConnection->ReceiveCommand();
     //Form1->Caption =Msg;

    try
    {
     Msg=Msg.SubString(2,Msg.Length()-2);
    Ind->Value= (Msg.ToInt()*4.98)/1023;
    }
     catch (Exception *ex)
    { ; }



         //  
    SerialConnection->SendCommand("!GetA\r");
    Msg = SerialConnection->ReceiveCommand();

    //Form1->Caption =Msg;

     try
    {
     Msg=Msg.SubString(2,Msg.Length()-2);
     MaskEdit1->Text= Msg.SubString(1,5);
     MaskEdit2->Text= Msg.SubString(6,8);
     MaskEdit3->Text= (Msg.SubString(17,2)).ToInt();
     

      //  
     if(Led3->Value)
     Led3->Value=False;
     else
     Led3->Value=True;





    Ind1->Value =(Msg.SubString(14,3)).ToInt();

    Temp->Value =  Ind1->Value;
     }
       catch (Exception *ex)
     {; }

         try
    {
    //    
    if( Ind1->Value > MaskEdit3->Text.ToInt())
                {
                Led1->Value=true;
                Led2->Value=false;
                }
          else
          {
          Led1->Value=false;
          Led2->Value=true;

          }
          /*
     //  
     if(Led3->Value)
     Led3->Value=False;
     else
     Led3->Value=True;
            */

       }
       catch (Exception *ex)
     {; }

  //  
     SerialConnection->SendCommand("!AlG1\r");
     Msg = SerialConnection->ReceiveCommand();
        try
    {
     Msg=Msg.SubString(2,Msg.Length()-2);
     MaskEdit5->Text= Msg.SubString(1,5);
     MaskEdit6->Text= Msg.SubString(6,8);
     MaskEdit7->Text = Msg.SubString(14,2);
      //MaskEdit17->Text = Msg.SubString(14,2);


        }
       catch (Exception *ex)
     {; }


       //   2
     SerialConnection->SendCommand("!AlG2\r");
     Msg = SerialConnection->ReceiveCommand();
        try
    {
     Msg=Msg.SubString(2,Msg.Length()-2);
     MaskEdit8->Text= Msg.SubString(1,5);
     MaskEdit9->Text= Msg.SubString(6,8);
     MaskEdit10->Text= Msg.SubString(14,2);


        }
       catch (Exception *ex)
     {; }

       //   3
     SerialConnection->SendCommand("!AlG3\r");
     Msg = SerialConnection->ReceiveCommand();
        try
    {
     Msg=Msg.SubString(2,Msg.Length()-2);
     MaskEdit11->Text= Msg.SubString(1,5);
     MaskEdit12->Text= Msg.SubString(6,8);
     MaskEdit13->Text= Msg.SubString(14,2);


        }
       catch (Exception *ex)
     {; }

       //   4
     SerialConnection->SendCommand("!AlG4\r");
     Msg = SerialConnection->ReceiveCommand();
        try
    {
     Msg=Msg.SubString(2,Msg.Length()-2);
     //Form1->Caption =Msg;
     MaskEdit14->Text= Msg.SubString(1,5);
     MaskEdit15->Text= Msg.SubString(6,8);
     MaskEdit16->Text= Msg.SubString(14,2);


        }
       catch (Exception *ex)
     {; }






  delete SerialConnection;




}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
    // 
      AnsiString Msg;
      Timer1->Enabled = False;
     TSerialConnection * SerialConnection = new TSerialConnection(PORT);
      // DAC
    Msg="!Dac"+MaskEdit4->Text+ "\r";
    //Form1->Caption=Msg;
      SerialConnection->SendCommand(Msg);
      Msg = SerialConnection->ReceiveCommand();

    // 
    Msg="!SetA"+MaskEdit1->Text+ MaskEdit2->Text+MaskEdit3->Text+ "\r" ;
    SerialConnection->SendCommand(Msg);
    Msg = SerialConnection->ReceiveCommand();


    
     delete SerialConnection;
     Timer1->Enabled = True;

}



void __fastcall TForm1::MaskEdit1Click(TObject *Sender)
{
  Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit2Click(TObject *Sender)
{
    Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit3Click(TObject *Sender)
{
     Timer1->Enabled = False;
}
//---------------------------------------------------------------------------
   void __fastcall TForm1::MaskEdit4Click(TObject *Sender)
{
       Timer1->Enabled = False;
}
//---------------------------------------------------------------------------
 void __fastcall TForm1::MaskEdit5Click(TObject *Sender)
{
  Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit6Click(TObject *Sender)
{
 Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit7Click(TObject *Sender)
{
 Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit8Click(TObject *Sender)
{
Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit9Click(TObject *Sender)
{
Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit10Click(TObject *Sender)
{
Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit11Click(TObject *Sender)
{
Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit12Click(TObject *Sender)
{
 Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit13Click(TObject *Sender)
{
 Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit14Click(TObject *Sender)
{
Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit15Click(TObject *Sender)
{
Timer1->Enabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MaskEdit16Click(TObject *Sender)
{
Timer1->Enabled = False;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button2Click(TObject *Sender)
{
      // 
      AnsiString Msg;
      Timer1->Enabled = False;
     TSerialConnection * SerialConnection = new TSerialConnection(PORT);

    // 
     Msg="!Alr1"+MaskEdit5->Text+ MaskEdit6->Text+MaskEdit7->Text+ "\r" ;
    SerialConnection->SendCommand(Msg);
    Msg = SerialConnection->ReceiveCommand();


     Msg="!Alr2"+MaskEdit8->Text+ MaskEdit9->Text+MaskEdit10->Text+ "\r" ;
    SerialConnection->SendCommand(Msg);
    Msg = SerialConnection->ReceiveCommand();

     Msg="!Alr3"+MaskEdit11->Text+ MaskEdit12->Text+MaskEdit13->Text+ "\r" ;
    SerialConnection->SendCommand(Msg);
    Msg = SerialConnection->ReceiveCommand();

 Msg="!Alr4"+MaskEdit14->Text+ MaskEdit15->Text+MaskEdit16->Text+ "\r" ;
    SerialConnection->SendCommand(Msg);
    Msg = SerialConnection->ReceiveCommand();



     delete SerialConnection;
     Timer1->Enabled = True;

}
//---------------------------------------------------------------------------


