//#############################################
//#                     #
//#       12.09.2013 alexshipov@gmail.com     #
//############################################# 
#include <windows.h>
#include <TCHAR.H > 
#include <conio.h> 
#include <stdio.h>


//     
OVERLAPPED over;
//#define PORT "Com5"

//---------------------------------------------------------------------------
// 3     
#define READ_TIMEOUT_TOTAL  500
//   600
#define READ_TIMEOUT      (READ_TIMEOUT_TOTAL/5)


class TSerialConnection
{
 

public:
        TDCB DCB;
        HANDLE SerialHandle;
        void __fastcall SendCommand(AnsiString Command);
        AnsiString __fastcall ReceiveCommand();
 
        TSerialConnection(AnsiString comPort);
        ~TSerialConnection(void);
 
};

TSerialConnection::TSerialConnection(AnsiString comPort)
{
       comPort= "\\\\.\\" + comPort;  //       10
       
        SerialHandle = CreateFile( comPort.UpperCase().c_str(), GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING,0, NULL);
        memset(&DCB, 0, sizeof(DCB));
        DCB.DCBlength = sizeof(DCB);
        GetCommState(SerialHandle, &DCB);
        DCB.BaudRate = CBR_9600;
        DCB.ByteSize = 8;
        DCB.fBinary=1;

        DCB.Parity = NOPARITY;
        DCB.StopBits = ONESTOPBIT;
        DCB.fParity = 0;
        DCB.fOutxCtsFlow = 0;
        DCB.fOutxDsrFlow = 0;
        DCB.fOutX = 0;
        DCB.fInX = 0;
        DCB.fErrorChar = 0;
        DCB.fRtsControl = 0;
        SetCommState(SerialHandle, &DCB);
        COMMTIMEOUTS ct;
        ct.ReadIntervalTimeout = 0;
        ct.ReadTotalTimeoutMultiplier = 0;
        ct.ReadTotalTimeoutConstant = READ_TIMEOUT;
        ct.WriteTotalTimeoutMultiplier = 0;
        ct.WriteTotalTimeoutConstant = 0;
        SetCommTimeouts(SerialHandle, &ct);
}
 
//---------------------------------------------------------------------------
TSerialConnection::~TSerialConnection(void)
{
        CloseHandle(SerialHandle);
}
//---------------------------------------------------------------------------
void __fastcall TSerialConnection::SendCommand(AnsiString Command)
{
        PurgeComm(SerialHandle,PURGE_TXCLEAR|PURGE_RXCLEAR|PURGE_TXABORT|PURGE_RXABORT);
        DWORD nb;
        if (SerialHandle!=INVALID_HANDLE_VALUE)
        {
 
                DWORD dwBytesWritten;
                int rc;
 
                WriteFile(SerialHandle, Command.c_str(),Command.Length(), &dwBytesWritten, NULL);
 
        }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TSerialConnection::ReceiveCommand()
{
        AnsiString Result;
        bool IsError=true;
        if (SerialHandle!=INVALID_HANDLE_VALUE)
        {
                char buffer[1024];
                DWORD dwBytesRead;
                DWORD dwTotal = 0;
                DWORD dwTimeout = 0;

                memset(buffer,0,sizeof(buffer));
                do
                {
                        ReadFile(SerialHandle, buffer+dwTotal,sizeof(buffer)-dwTotal, &dwBytesRead, NULL);
                       if (dwBytesRead != 0)
                        {
                                dwTotal += dwBytesRead;
                                if (strchr(buffer, '\r') != NULL)
                                {
                                        IsError=false;
                                        break;
                                }
                        }
                        dwTimeout += READ_TIMEOUT;
                }
                while (dwTimeout < READ_TIMEOUT_TOTAL);


                if(!IsError)
                        Result = buffer;
                else
                       Result = "";

        }
        if(Result!="")

                 //     
        	//return Result.SubString(1,Result.Pos("\n")-1);

                       	return Result;//  
        return Result;
}

void WriteCom(AnsiString msg)
{//  
TSerialConnection * SerialConnection = new TSerialConnection(PORT);
SerialConnection->SendCommand(msg);
delete SerialConnection;
 }
AnsiString  ReadCom(void)
{AnsiString data;
 TSerialConnection * SerialConnection = new TSerialConnection(PORT);
  data =SerialConnection->ReceiveCommand();
  return data;
delete SerialConnection;

 }

// COM    XP  NT

  AnsiString EnumerateSerialPorts()
  {
    //    ?
    OSVERSIONINFO osvi;
    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    BOOL bGetVer = GetVersionEx(&osvi);

    //  NT  API QueryDosDevice
    if(bGetVer && (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT))
      {
        //  QueryDosDevice    
        //    COMx.
       //   ,      
        TCHAR szDevices[65535];
        DWORD dwChars = QueryDosDevice(NULL, szDevices, 65535);
        if(dwChars)
          {
            int i=0;

              for (;;)
                {
                  //    
                  TCHAR* pszCurrentDevice = &szDevices[i];

                  //    "COMXXX"   
                  int nLen = _tcslen(pszCurrentDevice);
                    if(nLen < 6 && _tcsnicmp(pszCurrentDevice, _T("COM"), 3)
                      == 0)

                      {

                       Form1->sComboBox1->Items->Add (pszCurrentDevice);

                         }

                  //     
                  while(szDevices[i] != _T('\0'))
                    i++;

                  //    
                    i++;

                  //     ,
                  //    
                  // NULL,    
                  if(szDevices[i] == _T('\0'))
                    break;
                } // for (;;)
            } // if(dwChars)
      } // if(bGetVer && (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT))
    else
      ;
  }

 //---------------------------------------------------------------------------
